import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.stage.Stage;
import logic.Song;

import java.util.LinkedList;


public class MusicPlayer extends Application {
    private final String HEADING_TEXT = "My Songs";

    private Scene scene;
    private MusicPlayerController controller;

    @Override
    public void start(Stage primaryStage) throws Exception {
        FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("FXMLMusicPlayer.fxml"));
        Parent root = fxmlLoader.load();

        controller = (MusicPlayerController) fxmlLoader.getController();
        scene = new Scene(root);

        initPlaylist();
        initPrimaryStage(primaryStage);
    }

    public static void main(String[] args) {
        launch(args);
    }

    private void initPrimaryStage(final Stage primaryStage) {
        primaryStage.setTitle(HEADING_TEXT);
        primaryStage.setScene(scene);

        // important for resizing
        primaryStage.setMinWidth(controller.getMainPaneWidth());
        primaryStage.setMinHeight(controller.getMainPaneHeight());

        primaryStage.sizeToScene();
        primaryStage.show();

        primaryStage.setResizable(false);
        controller.showFirstSong();
    }

    private void initPlaylist() {
        Song song1 = new Song("Sueño De Dahlia", "Marioneta", new Image("http://imgjam2.jamendo.com/albums/s106/106254/covers/1.200.jpg"), "http://storage-new.newjamendo.com?trackid=902462&format=mp31");
        Song song2 = new Song("Monique", "Convey", new Image("http://imgjam2.jamendo.com/albums/s6/6018/covers/1.200.jpg"), "http://storage-new.newjamendo.com?trackid=49519&format=mp31");
        Song song3 = new Song("Birds of Fire", "Rap 'n' Roll", new Image("http://imgjam2.jamendo.com/albums/s3/3062/covers/1.200.jpg"), "http://storage-new.newjamendo.com?trackid=21925&format=mp31");
        Song song4 = new Song("Protologic", "Ibiza",  new Image("http://imgjam2.jamendo.com/albums/s49/49400/covers/1.200.jpg"), "http://storage-new.newjamendo.com?trackid=392998&format=mp31");
        Song song5 = new Song("Staggered Crossing", "Grow", new Image("http://imgjam2.jamendo.com/albums/s7/7175/covers/1.200.jpg"), "http://storage-new.newjamendo.com?trackid=78801&format=mp31");

        LinkedList<Song> songs = new LinkedList<Song>();
        songs.add(song1);
        songs.add(song2);
        songs.add(song3);
        songs.add(song4);
        songs.add(song5);

        controller.init(songs);
    }
}
